package journal.action;

import java.sql.SQLException;

import journal.reader.TransactionJournalEntry;
import journal.reader.Options;

public class SQLLoader extends SQLUpdater 
{
	private int batchSize;
	
	public SQLLoader() {
	}

	@Override
	public void setDefaultOptions(Options options) {
		super.setDefaultOptions(options);
		options.setOptionName(this.getClass().getName(), "batchsize", "100", 
				new Options.OptionSetter() {
					public void set(String key, String value) {
						batchSize = Integer.parseInt(value);
					}
				}
		);
	}
	
	@Override
	public void start() throws Exception {
		super.start();

		sf.dropTables();
		sf.setBatchSize(batchSize);
	}
	
	@Override
	public void commitMarker(TransactionJournalEntry entry) throws Exception {
		try {
			sf.commitMarker(entry);
		} catch (SQLException ex) {
			handleSQLException(ex);
		}
	}

}
