package journal.filter;

import journal.reader.DataJournalEntry;

public class OpenAndHaveFilter extends BaseFilter 
{
	private boolean passThrough(DataJournalEntry dataEntry) {
		String tableName = dataEntry.getTableName();
		
		if (tableName.equals("db.have") || 
			tableName.equals("db.working") || 
			tableName.equals("db.locks") ||
			tableName.equals("db.resolve") ||
			tableName.equals("db.resolved")) {
			return false;
		}
		return true;
	}
	
	@Override
	public void putValue(DataJournalEntry entry) throws Exception {
		if (passThrough(entry)) {
			nextAction.putValue(entry);
		}
	}

	@Override
	public void replaceValue(DataJournalEntry entry) throws Exception {
		if (passThrough(entry)) {
			nextAction.replaceValue(entry);
		}
	}

	@Override
	public void deleteValue(DataJournalEntry entry) throws Exception {
		if (passThrough(entry)) {
			nextAction.deleteValue(entry);
		}
	}

}
